consider backing out bug 526194 and bug 526613 once the underlying issue is fixed
It looks like bug 526194 was really a session restore issue in the first place, namely bug 528440 and bug 528776. For the sake of code simplicity, we should look into backing the workaround fixes out once the underlying issue is fixed.